# coding: utf-8

"""
    iparapheur

    iparapheur v5.x main core application.  The main link between every sub-services, integrating business code logic. 

    The version of the OpenAPI document: DEVELOP
    Contact: iparapheur@libriciel.coop
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from iparapheur_internal.models.state import State
from iparapheur_internal.models.typology_representation import TypologyRepresentation
from typing import Optional, Set
from typing_extensions import Self

class FolderFilterDto(BaseModel):
    """
    FolderFilterDto
    """ # noqa: E501
    id: Optional[StrictStr] = None
    user_id: Optional[StrictStr] = Field(default=None, alias="userId")
    filter_name: Optional[Annotated[str, Field(min_length=2, strict=True, max_length=255)]] = Field(default=None, alias="filterName")
    type_id: Optional[StrictStr] = Field(default=None, alias="typeId")
    type: Optional[TypologyRepresentation] = None
    subtype_id: Optional[StrictStr] = Field(default=None, alias="subtypeId")
    subtype: Optional[TypologyRepresentation] = None
    search_data: Optional[StrictStr] = Field(default=None, alias="searchData")
    legacy_id: Optional[StrictStr] = Field(default=None, alias="legacyId")
    state: Optional[State] = None
    metadata_filters: Optional[Dict[str, StrictStr]] = Field(default=None, alias="metadataFilters")
    var_from: Optional[datetime] = Field(default=None, alias="from")
    to: Optional[datetime] = None
    __properties: ClassVar[List[str]] = ["id", "userId", "filterName", "typeId", "type", "subtypeId", "subtype", "searchData", "legacyId", "state", "metadataFilters", "from", "to"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of FolderFilterDto from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * OpenAPI `readOnly` fields are excluded.
        * OpenAPI `readOnly` fields are excluded.
        """
        excluded_fields: Set[str] = set([
            "id",
            "user_id",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of type
        if self.type:
            _dict['type'] = self.type.to_dict()
        # override the default output from pydantic by calling `to_dict()` of subtype
        if self.subtype:
            _dict['subtype'] = self.subtype.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of FolderFilterDto from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "userId": obj.get("userId"),
            "filterName": obj.get("filterName"),
            "typeId": obj.get("typeId"),
            "type": TypologyRepresentation.from_dict(obj["type"]) if obj.get("type") is not None else None,
            "subtypeId": obj.get("subtypeId"),
            "subtype": TypologyRepresentation.from_dict(obj["subtype"]) if obj.get("subtype") is not None else None,
            "searchData": obj.get("searchData"),
            "legacyId": obj.get("legacyId"),
            "state": obj.get("state"),
            "metadataFilters": obj.get("metadataFilters"),
            "from": obj.get("from"),
            "to": obj.get("to")
        })
        return _obj


